1. 程式人生 > >Leetcode-001-Two sum

Leetcode-001-Two sum

題目

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

翻譯

給定一個整數陣列和一個目標值,找出陣列中和為目標值的兩個數。
你可以假設每個輸入只對應一種答案,且同樣的元素不能被重複利用。

思路分析

  1. 暴力法。雙重for迴圈,效率低O(N^2)
  2. 使用HashMap【執行緒不安全】或者是hashTable[使用sychronized,執行緒安全]。底層實現是entry陣列+單鏈表。自帶containkey和containValue。

程式碼

下面這段程式碼可以精簡,不過這樣的思路更清晰些。更有所愛,兩個演算法的效率都是O(n),後者相比更優秀些。

class Solution {
    public int[] twoSum(int[] nums, int target) {
       int[] result=new int[2];
        Map<Integer,Integer> map = new HashMap<>();
        for (int i=0;i<nums.length;i++){
            map.put(nums[i],i );
        }
        //搜尋
        for (int j=0;j<nums.length;j++){
            if (map.containsKey(target-nums[j])){
                result[0]=j;
                result[1]=map.get(target-nums[j]);
                if (result[0]!=result[1]){
                    break;
                }
            }
        }
        return result;
    }
}
class Solution {
    public int[] twoSum(int[] nums, int target) {
       int[] result=new int[2];
        Map<Integer,Integer> map = new HashMap<>();
        for (int i=0;i<nums.length;i++){
        	//每一次把數放入map之前先檢查map中是否已經存在和當前數配對的另外一個數
            if (map.containsKey(target-nums[i])){ 
                result[0]=map.get(target-nums[i]);
                result[1]=i;
            }
            map.put(nums[i],i );
        }

        return result;
    }
}